#!/bin/sh

##################################################################################
#                                 _             _
#                                | |_  ___ _ __(_)__ _
#                                | ' \/ -_) '_ \ / _` |
#                                |_||_\___| .__/_\__,_|
#                                         |_|
#
##################################################################################
#
# Company: hepia
# Author: Joachim Schmidt <joachim.schmidt@hesge.ch>
#
# Project Name: scalp_user_firmware
# Target Device: hepia-cores.ch:scalp_node:part0:0.1 xc7z015clg485-2
# Tool version: 2020.2
# Description: Generate software application
#
# Last update: 2021-03-17 07:44:47
#
##################################################################################

PRJ_DIR=..

echo "> Generate software applications..."
xsdk -batch -source ./gen_sw_apps_scalp_user_firmware.tcl -notrace

echo "> Copy application file in current directory..."
mkdir -p ${PRJ_DIR}/app/
cp ${PRJ_DIR}/scalp_user_firmware/scalp_user_firmware.sdk/scalp_user_firmware_app/Debug/scalp_user_firmware_app.elf ${PRJ_DIR}/app/scalp_user_firmware_app.elf
cp ${PRJ_DIR}/scalp_user_firmware/scalp_user_firmware.sdk/scalp_user_firmware_hw_platform_0/system.hdf ${PRJ_DIR}/app/scalp_user_firmware.hdf
cp ${PRJ_DIR}/scalp_user_firmware/scalp_user_firmware.sdk/scalp_user_firmware_hw_platform_0/ps7_init.tcl ${PRJ_DIR}/app/ps7_init.tcl

echo "> Done"

